#ifndef __537_THREAD__
#define __537_THREAD__

#include <stdlib.h>
#include <stdio.h>
#include <assert.h>
#include <ucontext.h>
#include "queue.h"

/*LOCK STRUCT*/
typedef struct __lock_t_
{	int locked;
	ucontext_t *owner;
	queue_t waiting;
} lock_t;

/*CONDITION STRUCT*/
typedef struct __cond_t_
{	queue_t waiting;
} cond_t;

void thread_libinit();
void thread_create(void func(void *), void *arg);
void thread_yield();
void thread_lock_init(lock_t *lock);
void thread_cond_init(cond_t *cond);
void thread_lock(lock_t *lock);
void thread_unlock(lock_t *lock);
void thread_wait(lock_t *lock, cond_t *cond);
void thread_signal(cond_t *cond);
int  thread_waitall();
void *Malloc(size_t size);
void Swapcontext(ucontext_t *oucp, ucontext_t *ucp);
void Getcontext(ucontext_t *ucp);

#endif
