#include "537thread.h"
/*THREAD DATA*/
static const int STACKSIZE = 1024*1024;
static const int DEBUG = 0;
static const int MHEAD = 0;

static ucontext_t bigbrother;
int m_waitall = 0;
static ucontext_t master;
static ucontext_t *running;

static queue_t ready;

static int thread_ctr = 0;
/*END DATA*/

void Enqueue(queue_t *q, ucontext_t *ctx)
{	queue_enqueue(q, (void *)(ctx));
}

ucontext_t *Dequeue(queue_t *q)
{	return (ucontext_t *)queue_dequeue(q);
}

void thread_watcher()
{	if(MHEAD) {printf("THREAD_WASH\n"); fflush(stdout);}
	while(1) {
		while(!queue_empty(&ready)) {
			running = Dequeue(&ready);
			Swapcontext(&bigbrother, running);
			if(DEBUG) {printf("back in wash\n"); fflush(stdout);}
			if(running == &master) {
				//the master has died!!!! kill EVERYONE!!!!!111
				if(DEBUG){printf("the master is dead\n"); fflush(stdout);}
				free(master.uc_stack.ss_sp);
				//fyi: the ronin are masterless warriors				
				while(!queue_empty(&ready)) {
					ucontext_t *ctx = Dequeue(&ready);
					free(ctx->uc_stack.ss_sp);
					free(ctx);
				}
			} else if(running) {
				//peasent thread has finished it work and is of no more use... kill it
				if(DEBUG){printf("killing peasent\n"); fflush(stdout);}
				free(running->uc_stack.ss_sp);		//go to the finished threads address and steal its stack,
				free(running);						//then mercilessly kill the thread
				thread_ctr--;						//appropiately decrement cencus
			} else {
				//if(DEBUG){printf("running = null aka thread yielded!\n"); fflush(stdout);}
			}
		}
		if(DEBUG) {printf("out of loop swap"); fflush(stdout);}
		if(m_waitall) {
			Swapcontext(&bigbrother, &master);
		} else {
			fprintf(stderr, "error: deadlock has occurred\n");
			break;
		}
	}

	//clear big boys stack?
	if(MHEAD) {printf("THREAD_WASH END\n"); fflush(stdout);}
}

void context_init(ucontext_t *ctx)
{	// initialize the context
	Getcontext(ctx);

	// make a new stack
	ctx->uc_stack.ss_sp   = Malloc(STACKSIZE); 
	ctx->uc_stack.ss_size = STACKSIZE;
}

ucontext_t *context_alloc()
{	if(MHEAD) {printf("CONTEXT_ALLOC\n"); fflush(stdout);}
	ucontext_t *ctx = (ucontext_t *)Malloc(sizeof(ucontext_t));
	
	context_init(ctx);

	return ctx;
}

/* thread_libinit
   initialize the thread library
*/
void thread_libinit()
{	if(MHEAD) {printf("THREAD_INIT\n"); fflush(stdout);}
	context_init(&bigbrother);
	context_init(&master);
	
	running = &master;

	queue_init(&ready);
	
	//create bigbrother to keep control of rebel threads (he sees everything)
	bigbrother.uc_link		= NULL;
	makecontext(&bigbrother, (void *)(thread_watcher), 0);
}

/* thread_create
   creates a new thread that will call function *func
   with argument *arg.
*/
void thread_create(void func(void *), void *arg)
{	if(MHEAD) {printf("THREAD_CREATE\n"); fflush(stdout);}
	//allocate new context
	ucontext_t *ctx = context_alloc();

	//change link to washer context
	ctx->uc_link		= &bigbrother;
	
	// makes the context for the new thread
	if(arg){
		makecontext(ctx, (void *)(func), 1, arg);
	} else {
		makecontext(ctx, (void *)(func), 0);
	}
	
	//inc thread count
	thread_ctr++;

	//add to ready
	Enqueue(&ready, ctx);
}

/* thread_yield
   causes the current thread to yield the CPU to the
   next runnable thread.
*/
void thread_yield()
{	if(MHEAD) {printf("THREAD_YIELD\n"); fflush(stdout);}
	if(!queue_empty(&ready))
	{	ucontext_t *prev = running;
		Enqueue(&ready, running);					//add running thread to ready queue
		running = NULL;						//thread yielded == still trucking == no KiLLing!
		Swapcontext(prev, &bigbrother);			//save old context, run the big boy
	}
}

/* thread_lock_init
   inititialize lock
*/
void thread_lock_init(lock_t *lock)
{	lock->locked = 0;					//set lock to false
	lock->owner = NULL;					//no one owns the lock
	queue_init(&(lock->waiting));			//allocate queue
}

void thread_cond_init(cond_t *cond)
{	queue_init(&(cond->waiting));			//allocate queue
}

void thread_lock(lock_t *lock)
{	if(MHEAD) {printf("THREAD_LOCK\n"); fflush(stdout);}
	while(lock->locked) {
		if(lock->owner ==  running) {
			fprintf(stderr, "error: thread_lock: lock is already held by caller\n");
		} else {
			if(DEBUG){ printf(": already held\n"); fflush(stdout);}
			ucontext_t *prev = running;
			Enqueue(&(lock->waiting), running);
			running = NULL;
			Swapcontext(prev, &bigbrother);
		}
	}
	if(DEBUG){ printf(": lock aquired\n"); fflush(stdout);}
	lock->locked = 1;
	lock->owner = running;
}

void thread_unlock(lock_t *lock)
{	if(MHEAD) {printf("THREAD_UNLOCK\n"); fflush(stdout);}
	if(lock->locked) {
		if(!queue_empty(&(lock->waiting))) {
			ucontext_t *tmp = Dequeue(&(lock->waiting));
			Enqueue(&ready, tmp);
		}
		lock->locked = 0;
		lock->owner = NULL;
	}
}

void thread_wait(lock_t *lock, cond_t *cond)
{	if(MHEAD) {printf("THREAD_WAIT\n"); fflush(stdout);}
	if(lock->locked) {
		if(lock->owner == running) {
			thread_unlock(lock);
			ucontext_t *prev = running;
			Enqueue(&(cond->waiting), running);
			running = NULL;
			Swapcontext(prev, &bigbrother);
			thread_lock(lock);
		} else {
			printf("error: thread_wait: caller not owner of lock\n"); fflush(stdout);
			exit(1);
		}
	} else {
		printf("error: thread_wait: must be called with lock held\n"); fflush(stdout);
		exit(1);
	}
}

void thread_signal(cond_t *cond)
{	if(MHEAD) {printf("THREAD_SIGNAL\n"); fflush(stdout);}
	if(!queue_empty(&(cond->waiting))) {
		Enqueue(&ready, Dequeue(&(cond->waiting)));
	}
}

/* thread_waitall
   when the main thread calls this, it waits for all other
   threads to finish. If all threads run to completion, thread_waitall()
   returns 0. If threads still exist but none are runnable,
   thread_waitall() returns -1.
*/
int thread_waitall()
{	if(MHEAD) {printf("THREAD_WAITALL\n"); fflush(stdout);}
	int rc;
	if(running == &master) {
		m_waitall = 1;
		if (!queue_empty(&ready)) {
			running = NULL;
			Swapcontext(&master, &bigbrother);		//save old context, run new one DUH!
		}
		rc = thread_ctr ? -1 : 0;				//-1 if their are more threads, 0 if not
	} else {
		fprintf(stderr, "error: thread_waitall: waitall can only be called by main thread\n");
		exit(1);
	}				
	return rc;
}

void 
Swapcontext(ucontext_t *oucp, ucontext_t *ucp)
{	if(swapcontext(oucp, ucp) == -1)
	{	fprintf(stderr, "error: swapcontext: swapcontext failed");
		exit(1);
	}
}

void
Getcontext(ucontext_t *ucp)
{	if(getcontext(ucp) == -1)
	{	fprintf(stderr, "error: getcontext: getcontext failed");
		exit(1);
	}
}
