#ifndef __537_THREAD__
#define __537_THREAD__

#include <stdlib.h>
#include <stdio.h>
#include <assert.h>
#include <ucontext.h>
#include "queue.h"

/* THREAD DATA */
const int STACKSIZE = 256*1024;
const int DEBUG = 1;

ucontext_t bigbrother;
ucontext_t *master;
ucontext_t *running;

queue_t *ready;

int thread_ctr = 0;

/*LOCK DATA*/
typedef struct __lock_t_
{	int locked;
	ucontext_t *owner;
	queue_t *waiting;
} lock_t;

/*CONDITION DATA*/
typedef struct __cond_t_
{	queue_t *waiting;
} cond_t;

void thread_libinit();
void thread_create(void func(void *), void *arg);
void thread_yield();
void thread_lock_init(lock_t *lock);
void thread_cond_init(cond_t *cond);
void thread_lock(lock_t *lock);
void thread_unlock(lock_t *lock);
void thread_wait(lock_t *lock, cond_t *cond);
void thread_signal(cond_t *cond);
int  thread_waitall();
void *Malloc(size_t size);

#endif
