#ifndef __QUEUE__
#define __QUEUE__

#include <stdlib.h>
#include <stdio.h>
#include <assert.h>

typedef struct __queue_node
{	void *data;
	struct __queue_node *next;
} queue_node;

typedef struct __queue_t
{	int size;
	queue_node *head;
	queue_node *tail;
} queue_t;

void *queue_alloc();
void  queue_enqueue(queue_t *q, void *elem);
void *queue_dequeue(queue_t *q);
int   queue_empty(const queue_t *q);
void  queue_free(queue_t *q);
void  queue_print(const queue_t *q);

#endif
