#include <stdlib.h>
#include <stdio.h>
#include "537thread.h"

lock_t lock;
cond_t ready;
char * str = "";
int run = 1;

void thread1(void)
{
	thread_lock(&lock);
	while (run) {
		thread_wait(&lock, &ready);
		printf(str);
	}
	thread_unlock(&lock);

	printf("thread1 complete\n");
}

void thread2(void)
{
	str = "Line 1\n";
	thread_signal(&ready);
	thread_yield();

	str = "Line 2\n";
	thread_signal(&ready);
	thread_yield();

	run = 0;
	printf("thread2 complete\n");
}


int main(int argc, char * args[])
{
	thread_libinit();

	thread_lock_init(&lock);
	thread_cond_init(&ready);

	thread_create((void *)thread1, 0);
	thread_create((void *)thread2, 0);

	if (thread_waitall() < 0)
		printf("Deadlock occurred\n");
	else
		printf("All threads exited\n");

	return 0;
}
