#include <stdio.h>
#include "537thread.h"

int nIncrements = 0;
int globalCounterA = 0;
int globalCounterB = 0;
lock_t guardGlobalA, guardGlobalB;

void *threadIncrements(void *id)
{
  int threadId = (int)id;
  int i;
  for(i=0;i<nIncrements;i++){
    thread_lock(&guardGlobalA);
    globalCounterA++;    
    thread_unlock(&guardGlobalA);
    thread_yield();
    thread_lock(&guardGlobalB);
    globalCounterB+= 2;    
    thread_unlock(&guardGlobalB);    
  }
  return NULL;
}

int main(int argc, char **argv)
{
  int nThreads = atoi(argv[1]);
  nIncrements = atoi(argv[2]);
  int i;
  thread_libinit();
  thread_lock_init(&guardGlobalA);
  thread_lock_init(&guardGlobalB);

  for(i=0;i<nThreads;i++){
    thread_create(threadIncrements,(void *)i);
  }
  thread_waitall();

  printf("For A, number of increments must be %d and it is %d\n", nThreads*nIncrements, globalCounterA);
  printf("For B, number of increments must be %d and it is %d\n", 2*nThreads*nIncrements, globalCounterB);
  return 0;
}
